package com.example.ali.control;

import android.graphics.Color;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.os.StrictMode;

import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import iotcloud.*;
import java.io.*;
import java.util.concurrent.*;
import android.os.Handler;

/**
 * This is a simple alarm controller for Android phone based on the code from Ali Younis
 * @author Rahmadi Trimananda <rtrimana@uci.edu>
 * @version 1.0
 */
public class MainActivity extends AppCompatActivity implements View.OnClickListener {

    Button alarmButton;
    TextView alarmStatus;

    Table t1 = null;
    Semaphore mutex = new Semaphore(1);

    boolean alarmOn = false;

    private Handler handler = new Handler();
    private static final String CLOUD_SERVER = "http://dc-6.calit2.uci.edu/test.iotcloud/";
    private static final String PASSWORD = "reallysecret";
    private static final int LOCAL_MACHINE_ID = 400;
    private static final int LISTENING_PORT = -1;

    private Runnable runnable = new Runnable() {
        @Override
        public void run() {

            String strAlarm = "alarm";
            IoTString iotAlarm = new IoTString(strAlarm);

            // Insert custom code here
            try {
                Log.e("Ali:::::", "loop............");
                mutex.acquire();
                //t1 = new Table(CLOUD_SERVER, PASSWORD, LOCAL_MACHINE_ID, LISTENING_PORT, MainActivity.this);
                //t1.rebuild();
                t1.update();
                IoTString testValStatus = t1.getCommitted(iotAlarm);
                t1.update();

                int intStatus = 0;
                if(testValStatus != null) {
                    String strStatus = testValStatus.toString();
                    intStatus = Integer.parseInt(strStatus);
                }

                if (intStatus == 0) {
                    alarmStatus.setText("OFF");
                    alarmStatus.setTextColor(Color.BLUE);
                    //alarmSwitch.setChecked(false);
                    alarmOn = false;
                    Log.d("RAHMADI::::", "Set text to OFF and BLUE with alarm value: " + testValStatus);
                }
                else {// value 1
                    alarmStatus.setText("ON");
                    alarmStatus.setTextColor(Color.RED);
                    //alarmSwitch.setChecked(true);
                    alarmOn = true;
                    Log.d("RAHMADI::::", "Set text to ON and RED with alarm value: " + testValStatus);
                }
                mutex.release();

            } catch (Exception e) {
                StringWriter sw = new StringWriter();
                PrintWriter pw = new PrintWriter(sw);
                e.printStackTrace(pw);
                Log.e("ALI::::", sw.toString());
            }


            // Repeat every 2 seconds
            handler.postDelayed(runnable, 1000);
        }
    };


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

            try {
                Log.e("Ali::::", "Here1");
                t1 = new Table(CLOUD_SERVER, PASSWORD, LOCAL_MACHINE_ID, LISTENING_PORT, MainActivity.this);
                Log.e("Ali::::", "Here2");
                t1.rebuild(); // update
                Log.e("Ali::::", "Here3");

            } catch (Exception e) {

                StringWriter sw = new StringWriter();
                PrintWriter pw = new PrintWriter(sw);
                e.printStackTrace(pw);
                Log.e("ALI::::", sw.toString());

        }
        // TextViews
        alarmStatus = (TextView) findViewById(R.id.alarmStatus);
        alarmStatus.setText("OFF");
        alarmStatus.setTextColor(Color.BLUE);
        alarmButton = (Button) findViewById(R.id.alarmButton);
        alarmButton.setOnClickListener(this);

        handler.post(runnable);
    }

    public void onClick(View v) {

        if (v == alarmButton) {
            String strAlarm = "alarm";
            IoTString iotAlarm = new IoTString(strAlarm);
            String strStatusOn = "1";
            IoTString iotStatusOn = new IoTString(strStatusOn);
            String strStatusOff = "0";
            IoTString iotStatusOff = new IoTString(strStatusOff);

            Log.d("RAHMADI:::::", "Button pressed!");

            try {
                mutex.acquire();
                if (!alarmOn) {

                    try {
                        t1.update();
                        t1.startTransaction();
                        t1.addKV(iotAlarm, iotStatusOn);
                        t1.commitTransaction();
                        alarmOn = true;
                        alarmButton.setText("ON");
                    } catch (Exception e) {
                        StringWriter sw = new StringWriter();
                        PrintWriter pw = new PrintWriter(sw);
                        e.printStackTrace(pw);
                        Log.e("ALI::::", sw.toString());
                    }

                } else {

                    try {
                        t1.update();
                        t1.startTransaction();
                        t1.addKV(iotAlarm, iotStatusOff);
                        t1.commitTransaction();
                        alarmOn = false;
                        alarmButton.setText("OFF");
                    } catch (Exception e) {
                        StringWriter sw = new StringWriter();
                        PrintWriter pw = new PrintWriter(sw);
                        e.printStackTrace(pw);
                        Log.e("ALI::::", sw.toString());
                    }
                }
                mutex.release();

            } catch (Exception e) {
                StringWriter sw = new StringWriter();
                PrintWriter pw = new PrintWriter(sw);
                e.printStackTrace(pw);
                Log.e("ALI::::", sw.toString());
            }
        }
    }
}
